/*-
 * Copyright 2003 John-Mark Gurney
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: postoffice.h,v 1.3 2003/04/21 08:21:51 jmg Exp jmg $
 */

#ifndef _POSTOFFICE_H_
#define _POSTOFFICE_H_ 1

#define POSTOFFICE_MINVER	1
#define POSTOFFICE_PREFVER	1
#define POSTOFFICE_MAXVER	1

#define POSTOFFICE_NUMSUBIDS	8

struct po_devinfo {
	device_t	pd_dev;
	u_int8_t	pd_id;
	u_int8_t	pd_irq;
	u_int8_t	pd_reset;
	u_int8_t	pd_sleep;
};

enum po_dev_ivars {
	PO_IVAR_ID,
	PO_IVAR_IRQ,
	PO_IVAR_RESET,
	PO_IVAR_SLEEP,
};

#ifdef _KERNEL
#include "postoffice_if.h"
#endif

#endif /* _POSTOFFICE_H_ */
