#
# Copyright 2003 John-Mark Gurney
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: postoffice_if.m,v 1.5 2003/04/21 08:21:51 jmg Exp jmg $
#

#include <sys/bus.h>

INTERFACE postoffice;

# Read/Write to the postoffice
# return 0 on success
# errno on failure
# id device id (3 bits)
# register to read/write
# data
METHOD int read {
	device_t dev;
	u_int8_t	id;
	u_int8_t	reg;
	u_int8_t	*data;
};

METHOD int write {
	device_t dev;
	u_int8_t	id;
	u_int8_t	reg;
	u_int8_t	data;
};

METHOD void set_durrec {
	device_t dev;
	u_int8_t id;
	u_int8_t dur;
	u_int8_t rec;
}

# These methods doesn't belong here, but I want to get the chip working!
METHOD void gpio {
	device_t dev;
	u_int8_t	pin;
	u_int8_t	val;
};

METHOD void enable_ints {
	device_t dev;
	u_int8_t	intr;
};
