/*-
 * Copyright 2003 John-Mark Gurney
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: videosubdev.c,v 1.3 2003/04/30 16:28:48 jmg Exp jmg $
 */

#include <sys/param.h>
#include <sys/kernel.h>
#include <sys/systm.h>
#include <sys/module.h>
#include <sys/malloc.h>
#include <sys/bus.h>

#include <dev/videocode/videosubdev.h>
#include "videosubdev_if.h"

static moduledata_t mod_data = {
        "videosubdev",
        NULL,   /* we use the DEPEND to do our ref counting for us. */
        0
};

DECLARE_MODULE(videosubdev, mod_data, SI_SUB_EXEC, SI_ORDER_ANY);
MODULE_VERSION(videosubdev, VIDEOSUBDEV_PREFVER);

static MALLOC_DEFINE(M_VSD, "videosubdev", "Video Subdevice");

#if 0
int
videosubdev_ioctl_children(device_t dev, u_long cmd, caddr_t data, int fflag,
	struct thread *td)
{
	int error, i, c;
	device_t *devlist;

	if ((error = device_get_children(dev, &devlist, &c)))
		return error;

	error = ENXIO;
	for (i = 0; error == ENXIO && i < c; i++) {
		if ((error = VIDEOSUBDEV_IOCTL(devlist[i], cmd, data, fflag,
		    td)) == ENXIO)
			/* not found, call it's children */
			error = videosubdev_ioctl_children(devlist[i],
			    cmd, data, fflag, td);
	}

	free(devlist, M_TEMP);

	return error;
}
#endif
