#
# Copyright 2003 John-Mark Gurney
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: videosubdev_if.m,v 1.4 2003/04/30 16:28:48 jmg Exp jmg $
#

#include <sys/conf.h>
#include <sys/bus.h>
#include <dev/videocode/videosubdev.h>

INTERFACE videosubdev;

#
# Default implementations of some methods.
#
CODE {
	static void null_intr(device_t dev) { };

	static int null_zero(device_t dev) { return 0; };

	static int null_ioctl(device_t dev, u_long cmd, caddr_t data, int fflag, struct thread *td) {
		return ENXIO;
	}
};

METHOD int open {
	device_t dev;
} DEFAULT null_zero;

METHOD void intr {
	device_t dev;
} DEFAULT null_intr;

# call sub ioctl
METHOD int ioctl {
	device_t dev;
	u_long cmd;
	caddr_t data;
	int fflag;
	struct thread *td;
} DEFAULT null_ioctl;

METHOD int close {
	device_t dev;
} DEFAULT null_zero;
