/*-
 * Copyright 2003 John-Mark Gurney
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: zr_core.h,v 1.8 2003/04/30 16:22:47 jmg Exp $
 */

#ifndef _ZR_CORE_H_
#define _ZR_CORE_H_ 1

#include "postoffice_if.h"

int zr_core_attach(struct zr_softc *zr);
void zr_reset(struct zr_softc *zr);
void zr_enable(struct zr_softc *zr);
void zr_disable(struct zr_softc *zr);
void zr_enable_ints(struct zr_softc *zr);
void zr_disable_ints(struct zr_softc *zr);
int zr_mask_free(struct zr_softc *zr);
int zr_po_read(struct zr_softc *zr, u_int8_t id, u_int8_t reg, u_int8_t *data);
int zr_po_write(struct zr_softc *zr, u_int8_t id, u_int8_t reg, u_int8_t data);
int zr_ioctl(struct zr_softc *zr, u_long cmd, caddr_t data, os_proc_t proc);
void zr_core_intr(struct zr_softc *zr);
int zr_goto_state(struct zr_softc *zr, zr_state_t st);

#endif /* _ZR_CORE_H_ */
