/*-
 * Copyright 2003 John-Mark Gurney
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: zr_os.h,v 1.11 2003/04/30 16:22:47 jmg Exp $
 */

#ifndef _ZR_OS_H_
#define _ZR_OS_H_ 1

typedef struct proc *os_proc_t;
struct zr_softc;
struct tvnorm;

uint32_t zr_read_asrs(struct zr_softc *zr, int off);
void zr_write_asrs(struct zr_softc *zr, int off, uint32_t val);
int verify_contig(os_proc_t proc, caddr_t base, int len, u_int32_t *phys);
void zr_find_coders(struct zr_softc *zr);
void zr_gpio(struct zr_softc *zr, u_int8_t pin, u_int8_t val);
struct zr_dmamem;
int zr_get_user_buf(struct zr_softc *zr, bus_dma_tag_t pt,
	struct zr_dmamem **zd, caddr_t uaddr, int size, os_proc_t proc,
	int nsegs);
int zr_free_user_buf(struct zr_softc *zr, struct zr_dmamem *zd);
u_int32_t zr_dmamem_to_phys(struct zr_softc *zr, struct zr_dmamem *zd);
int zr_get_mem(struct zr_softc *zr, bus_dma_tag_t pt, struct zr_dmamem *zd,
	int size, int nsegs);
int zr_free_mem(struct zr_softc *zr, struct zr_dmamem *zd);
void zr_release_coders(struct zr_softc *zr);
int zr_get_user_uio(struct zr_softc *zr, bus_dma_tag_t pt,
	struct zr_dmamem **zd, struct uio *uio, int nsegs, int read);
int zr_free_user_uio(struct zr_softc *zr, struct zr_dmamem *zd);
void zr_set_norm(struct zr_softc *zr, const struct tvnorm *tnp, int copy);

#endif /* _ZR_OS_H_ */
