/*-
 * Copyright 2003 John-Mark Gurney
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: zr36060_reg.h,v 2.1 2003/05/04 15:01:03 jmg Exp $
 */

#ifndef _ZR36060_H_
#define _ZR36060_H_ 1

struct zr60_softc {
	device_t z60_self;
	device_t z60_parent;
	u_int8_t	z60_id;
	u_int8_t	z60_rev;
	u_int8_t	z60_slp;
	u_int8_t	z60_rst;

	struct mtx	z60_lock;
	u_int	z60_norm_allocated	: 1;

	const struct tvnorm *z60_norm;
	device_t	z60_decoder;
#define IFCODERINVAL(z60, code)	if (zr36060_find_coders(z60), z60->z60_##code == NULL)
};

struct lpr {
	u_int8_t	SyncRst	: 1;
	u_int8_t		: 6;
	u_int8_t	Load	: 1;
};
struct cfsr {
	u_int8_t	CFIFO	: 2;
	u_int8_t	CBUSY	: 1;
	u_int8_t		: 4;
	u_int8_t	Busy	: 1;
};
struct mer {
	u_int8_t		: 3;
	u_int8_t	dht	: 1;
	u_int8_t	dqt	: 1;
	u_int8_t	dri	: 1;
	u_int8_t	com	: 1;
	u_int8_t	app	: 1;
};
struct isr {
	u_int8_t	DATERR	: 1;
	u_int8_t	END	: 1;
	u_int8_t	EOI	: 1;
	u_int8_t	EOAV	: 1;
	u_int8_t		: 2;
	u_int8_t	ProCnt	: 2;
};

typedef union {
#define _U_(name)	struct name	name
	_U_(lpr);
	_U_(cfsr);
	_U_(mer);
	_U_(isr);	/* isr and imr are similar/same */
#undef _U_
} rmd_t;

#endif /* _ZR36060_H_ */
